import glob
from rsml2pp import rsml2pp
from pp2xml_v2 import pp2xml

rfiles = glob.glob("../Root_data/MCT2_time-series/RSML/*.rsml")



# import data from rsml
pplants = {}
"""
for fname in rfiles:
    print(fname)
    basename = fname.split('/')[-1].split('.')[0]
    
    plant_code = '_'.join(basename.split('_')[2:4])
    fday = int(basename.split('_')[4][1:])
    
    pp = rsml2pp(fname)
    
    if plant_code not in pplants:
        pplants[plant_code]={fday:pp}
    else:
        pplants[plant_code][fday]=pp

    #if fday==13:
    #    print('_'.join(basename.split('_')[:5]))
    #    outfile = "../xml_tpoints/%s" % '_'.join(basename.split('_')[:5])
    #    xml = pp2xml(pp,outfile,"../xml/ConfigurationTemplate.xml")
    



HN_R1=[[2,13,5,4,2,2,2],
[15,2,2,2,3,3],
[31,11,4,3,4],
[36,22,8,6,5],
[30,12,3],
[13,19,6],
[14,21,7],
[20,3],
[22,4],
[23,5],
[24,6],
[25,7],
[26,8],
[28,9],
[29,10],
[5,14],
[8,15],
[9,16],
[10,17],
[11,18],
[12,20]]


HN_R2=[[13,5,2,2,2,2],
[35,17,6,3,3],
[2,16,8,4],
[50,2,9,5],
[31,12,3],
[32,13,4],
[34,15,5],
[63,3],
[62,4],
[24,6],
[26,7],
[27,8],
[28,9],
[29,10],
[30,11],
[33,14],
[41,18],
[42,19],
[43,20],
[44,21],
[45,22],
[46,23],
[47,24]]



HN_R3=[[34,2,2,2,2,2],
[28,13,3,3,3],
[2,23,6,4],
[47,16,5,5],
[14,7,4],
[42,3],
[43,4],
[44,5],
[46,6],
[22,8],
[23,9],
[25,10],
[26,11],
[27,12],
[32,14],
[33,15],
[49,17],
[51,18],
[52,19],
[53,20],
[54,21],
[55,22],
[9,24],
[13,25]]





HN_R4=[[2,2,2,2,2,2,2],
[7,5,3,3,3],
[11,3,4,4]]


LN_R1 = [[14,6,3,3,2,2,2],
[29,17,7,6,5,3],
[2,2,2,2,4],
[27,15,5,4],
[13,16,6,5],
[28,3],
[42,4],
[43,5],
[19,7],
[20,8],
[21,9],
[22,10],
[23,11],
[24,12],
[25,13],
[26,14]]

LN_R2=[[24,2,8,6,2,2,2],
[10,10,5,4,6,5],
[20,11,2,2,4],
[14,7,3,3,5],
[2,17,7,5,7],
[19,9,4],
[23,16,6],
[29,6,9],
[27,3],
[26,4],
[28,5],
[18,8],
[21,4],
[22,15],
[8,18],
[9,19]]

LN_R3=[[2,4,2,2,2,2],
[11,2,3,4,3],
[9,3,4,3],
[10,5,5],
[18,6,6]]

LN_R4=[[19,2,2,2,2,2],
[60,24,15,4,3],
[43,11,3],
[45,13,4],
[46,14,5],
[47,15,6],
[55,17,8],
[56,18,9],
[57,19,10],
[49,20,11],
[2,21,12],
[48,16,14],
[71,31,16],
[76,34,17],
[72,32,18],
[35,3],
[36,4],
[37,5],
[38,6],
[39,7],
[40,8],
[41,9],
[42,10],
[44,12],
[59,22],
[64,25],
[65,26],
[66,27],
[68,28],
[70,30],
[74,33]]



tp_days = {'HN_R1':[13,11,9,7,5,3,1],'HN_R2':[13,11,9,5,3,1],'HN_R3':[13,11,9,5,3,1],'HN_R4':[13,11,9,7,5,3,1],
        'LN_R1':[13,11,9,7,5,3,1],'LN_R2':[13,11,9,7,5,3,1],'LN_R3':[11,9,7,5,3,1],'LN_R4':[13,11,9,5,3,1]}
        
all_trans = {'HN_R1':HN_R1,
        'HN_R2':HN_R2,
        'HN_R3':HN_R3,
        'HN_R4':HN_R4,
        'LN_R1':LN_R1,
        'LN_R2':LN_R2,
        'LN_R3':LN_R3,
        'LN_R4':LN_R4}

for pcode,days in tp_days.items():

    plant = pplants[pcode][days[0]]
    
    
    plant.lengthAtTime={rid:{} for rid in plant.length.keys()}

    for rid,rlen in plant.length.items():
        plant.lengthAtTime[rid][days[0]]=rlen

    for trans in all_trans[pcode]:
        for i,ref in enumerate(trans):
            plant.lengthAtTime[trans[0]][days[i]]=pplants[pcode][days[i]].length[ref]

    
    for rid,lats in plant.lengthAtTime.items():
        if len(lats)>1:
            ltimes=sorted(lats.keys())
            for i,day in enumerate(ltimes[:-1]):

                if lats[ltimes[i+1]]<lats[day]:
                    plant.lengthAtTime[rid][ltimes[i+1]]=lats[day]
    
    plant.lengthAtTime[-1]={13:2.0,1:2.0}


    outfile = "../xml_lat/%s" % pcode
    xml = pp2xml(plant,outfile,"../xml/ConfigurationTemplate.xml",days[0])

"""
